const express = require('express');
const http = require('http');

const app = express();

let port = 5000;
let ip = 'localhost';

const Server = (config, routers = null) => {
  if ((config['port'])){
    port = config.port; 
  }

  if ((config['ip'])){
    ip = config.ip;
  }

  if (routers) {
    routers.forEach((router) => {
      app.use('/api', router);
    });
  }

  const router = express.Router();
  router.get('/', (req, res) => {
    res.send('Hello World!');
  });

  app.use('/', express.static(config.distRoot));
  app.use('/node_modules', express.static('node_modules'));

  app.all('/*', (req, res) => {
    res.sendFile('index.html', { root: config.distRoot });
  });

  return {
    start: () => {
      const server = http.createServer(app);
      server.listen(port, ip)
        .on('listening', () => {
          const { port, address } = server.address();
          console.log(`Express server started on port ${port} at ${address}.`);   
        });  
    }
  }
};

module.exports = Server;