const tslint = require('gulp-tslint');
const fs = require('fs');

const config = GULP_ANGULAR_CONFIG.tslint;
const TS_LINT_CONFIG = (config.src) ? JSON.parse(fs.readFileSync(config.src, 'utf8')) : null; 
const TS_LINT_OPTIONS = {
  configuration: TS_LINT_CONFIG,
  formattersDirectory: config.formattersDirectory,
  formatter: config.formatter
};

const tslinter = (tsSrc, emitError = false) => {
  return gulp.src(tsSrc)
    .pipe(tslint(TS_LINT_OPTIONS))
    .pipe(tslint.report({ emitError: emitError, summarizeFailureOutput: true }));
};

exports.tslinter = tslinter;